[BITS 16]
[ORG 0]

jmp start
	
BOOTSEG EQU 0x07c0
INITSEG EQU 0x9000
SETUP	EQU 0x9020
SYSSEG  EQU 0x1000
	
bootmsg		db	'Loading',0
dot		db	'.',0

			
start:
	mov	[bootdrive], dl
	mov	ax, BOOTSEG
	mov	ds, ax
	mov	ax, INITSEG
	mov	es, ax
	xor	di, di
	xor	si, si
	mov	cx, 0x0200                  ; Bootsector is 512 bytes.
	cld
	rep
	movsb
	jmp	INITSEG:go
	
go:
	mov	ax, INITSEG
	mov	ds, ax
	mov	es, ax
	cli		
	mov	ss, ax
	mov	sp, 0xeeee
	sti

	mov	si, bootmsg
	call	write_message


	mov	ax, INITSEG
	mov	es, ax
	mov	bx, 0x0200
	call	reset_drive
	call	start_loading
	
	
	jmp	INITSEG: 0x0200		    ; setup loaded at 0x90200


reset_drive:
	
	push	ax
	mov	ah, 0
	int	0x13
	pop	ax
        ret

start_loading:	
	mov	ah, 0x02		    ; ah = read function at int 13h
	mov	al, 0x03		    ; al = the number of sectors to read
        mov	ch, 0			    ; ch = track number
	mov	cl, 0x02		    ; cl = starting sector
        mov	dl, [bootdrive]		    ; dl = drive number
        mov	dh, 0                       ; dh = head number

read_one_sector:
	push	ax
	mov	al, 0x1
	mov	ah, 0x2
	int	0x13
	push	bx
 	mov	si, dot
	call	write_message
	pop	bx
	pop	ax
	
	inc	cl               	    ; increment sector value
	dec	al			    ; decrement the number of sectors to read
	add	bx, 0x200		    ; increment the offset
	cmp	al, 0			    ; check al if all the sectors read
	je	load_finished
	call	reset_drive
	jmp	read_one_sector		    ; read next sector

load_finished:
	call    reset_drive
	ret



; -------------------------------------------------------------
	
write_message:
	lodsb			; DS:[SI] is read to al
	cmp	al, 0x0
	jz	end_message
	mov	ah, 0x0E	; teletype Mode
	mov	bx, 0007	; white on black attribute
	int	0x10
	jmp	write_message
	
end_message:
	ret
	
; -------------------------------------------------------------	


	bootdrive db 0


	times 510-($-$$) db 0
	dw 0xAA55
	
	
	
